diff --git a/src/backend/optimizer/path/joinpath.c b/src/backend/optimizer/path/joinpath.c
index 642f951093..d5880e42a0 100644
--- a/src/backend/optimizer/path/joinpath.c
+++ b/src/backend/optimizer/path/joinpath.c
@@ -48,29 +48,38 @@ static void try_partial_mergejoin_path(PlannerInfo *root,
 						   List *outersortkeys,
 						   List *innersortkeys,
 						   JoinType jointype,
-						   JoinPathExtraData *extra);
+						   JoinPathExtraData *extra,
+						   RelAggKind agg_kind,
+						   bool do_aggregate);
 static void sort_inner_and_outer(PlannerInfo *root, RelOptInfo *joinrel,
 					 RelOptInfo *outerrel, RelOptInfo *innerrel,
-					 JoinType jointype, JoinPathExtraData *extra);
+					 JoinType jointype, JoinPathExtraData *extra,
+					 RelAggKind agg_kind, bool do_aggregate);
 static void match_unsorted_outer(PlannerInfo *root, RelOptInfo *joinrel,
 					 RelOptInfo *outerrel, RelOptInfo *innerrel,
-					 JoinType jointype, JoinPathExtraData *extra);
+					 JoinType jointype, JoinPathExtraData *extra,
+					 RelAggKind agg_kind, bool do_aggregate);
 static void consider_parallel_nestloop(PlannerInfo *root,
 						   RelOptInfo *joinrel,
 						   RelOptInfo *outerrel,
 						   RelOptInfo *innerrel,
 						   JoinType jointype,
-						   JoinPathExtraData *extra);
+						   JoinPathExtraData *extra,
+						   RelAggKind agg_kind,
+						   bool do_aggregate);
 static void consider_parallel_mergejoin(PlannerInfo *root,
 							RelOptInfo *joinrel,
 							RelOptInfo *outerrel,
 							RelOptInfo *innerrel,
 							JoinType jointype,
 							JoinPathExtraData *extra,
-							Path *inner_cheapest_total);
+							Path *inner_cheapest_total,
+							RelAggKind agg_kind,
+							bool do_aggregate);
 static void hash_inner_and_outer(PlannerInfo *root, RelOptInfo *joinrel,
 					 RelOptInfo *outerrel, RelOptInfo *innerrel,
-					 JoinType jointype, JoinPathExtraData *extra);
+					 JoinType jointype, JoinPathExtraData *extra,
+					 RelAggKind agg_kind, bool do_aggregate);
 static List *select_mergejoin_clauses(PlannerInfo *root,
 						 RelOptInfo *joinrel,
 						 RelOptInfo *outerrel,
@@ -87,7 +96,9 @@ static void generate_mergejoin_paths(PlannerInfo *root,
 						 bool useallclauses,
 						 Path *inner_cheapest_total,
 						 List *merge_pathkeys,
-						 bool is_partial);
+						 bool is_partial,
+						 RelAggKind agg_kind,
+						 bool do_aggregate);
 
 
 /*
@@ -112,6 +123,9 @@ static void generate_mergejoin_paths(PlannerInfo *root,
  * however.  Path cost estimation code may need to recognize that it's
  * dealing with such a case --- the combination of nominal jointype INNER
  * with sjinfo->jointype == JOIN_SEMI indicates that.
+ *
+ * agg_info is passed iff partial aggregation should be applied to the join
+ * path.
  */
 void
 add_paths_to_joinrel(PlannerInfo *root,
@@ -120,7 +134,9 @@ add_paths_to_joinrel(PlannerInfo *root,
 					 RelOptInfo *innerrel,
 					 JoinType jointype,
 					 SpecialJoinInfo *sjinfo,
-					 List *restrictlist)
+					 List *restrictlist,
+					 RelAggKind agg_kind,
+					 bool do_aggregate)
 {
 	JoinPathExtraData extra;
 	bool		mergejoin_allowed = true;
@@ -267,7 +283,7 @@ add_paths_to_joinrel(PlannerInfo *root,
 	 */
 	if (mergejoin_allowed)
 		sort_inner_and_outer(root, joinrel, outerrel, innerrel,
-							 jointype, &extra);
+							 jointype, &extra, agg_kind, do_aggregate);
 
 	/*
 	 * 2. Consider paths where the outer relation need not be explicitly
@@ -278,7 +294,7 @@ add_paths_to_joinrel(PlannerInfo *root,
 	 */
 	if (mergejoin_allowed)
 		match_unsorted_outer(root, joinrel, outerrel, innerrel,
-							 jointype, &extra);
+							 jointype, &extra, agg_kind, do_aggregate);
 
 #ifdef NOT_USED
 
@@ -305,7 +321,7 @@ add_paths_to_joinrel(PlannerInfo *root,
 	 */
 	if (enable_hashjoin || jointype == JOIN_FULL)
 		hash_inner_and_outer(root, joinrel, outerrel, innerrel,
-							 jointype, &extra);
+							 jointype, &extra, agg_kind, do_aggregate);
 
 	/*
 	 * 5. If inner and outer relations are foreign tables (or joins) belonging
@@ -366,7 +382,9 @@ try_nestloop_path(PlannerInfo *root,
 				  Path *inner_path,
 				  List *pathkeys,
 				  JoinType jointype,
-				  JoinPathExtraData *extra)
+				  JoinPathExtraData *extra,
+				  RelAggKind agg_kind,
+				  bool do_aggregate)
 {
 	Relids		required_outer;
 	JoinCostWorkspace workspace;
@@ -376,6 +394,12 @@ try_nestloop_path(PlannerInfo *root,
 	Relids		outerrelids;
 	Relids		inner_paramrels = PATH_REQ_OUTER(inner_path);
 	Relids		outer_paramrels = PATH_REQ_OUTER(outer_path);
+	bool		success = false;
+
+	if (agg_kind == REL_AGG_KIND_PARTIAL)
+		joinrel = joinrel->grouped->needs_final_agg;
+	else if (agg_kind == REL_AGG_KIND_SIMPLE)
+		joinrel = joinrel->grouped->no_final_agg;
 
 	/*
 	 * Paths are parameterized by top-level parents, so run parameterization
@@ -422,10 +446,31 @@ try_nestloop_path(PlannerInfo *root,
 	initial_cost_nestloop(root, &workspace, jointype,
 						  outer_path, inner_path, extra);
 
-	if (add_path_precheck(joinrel,
-						  workspace.startup_cost, workspace.total_cost,
-						  pathkeys, required_outer))
+	/*
+	 * If the join output should be (partially) aggregated, the precheck
+	 * includes the aggregation and is postponed to create_grouped_path().
+	 */
+	if ((!do_aggregate &&
+		 add_path_precheck(joinrel,
+						   workspace.startup_cost, workspace.total_cost,
+						   pathkeys, required_outer)) ||
+		do_aggregate)
 	{
+		Path	   *path;
+		PathTarget *target;
+
+		/*
+		 * If the join output is subject to partial aggregation, the path must
+		 * have the appropriate target.
+		 */
+		if (!do_aggregate)
+			target = joinrel->reltarget;
+		else
+		{
+			Assert(joinrel->agg_info != NULL);
+			target = joinrel->agg_info->input;
+		}
+
 		/*
 		 * If the inner path is parameterized, it is parameterized by the
 		 * topmost parent of the outer rel, not the outer rel itself.  Fix
@@ -447,21 +492,58 @@ try_nestloop_path(PlannerInfo *root,
 			}
 		}
 
-		add_path(joinrel, (Path *)
-				 create_nestloop_path(root,
-									  joinrel,
-									  jointype,
-									  &workspace,
-									  extra,
-									  outer_path,
-									  inner_path,
-									  extra->restrictlist,
-									  pathkeys,
-									  required_outer));
+		path = (Path *) create_nestloop_path(root,
+											 joinrel,
+											 target,
+											 jointype,
+											 &workspace,
+											 extra,
+											 outer_path,
+											 inner_path,
+											 extra->restrictlist,
+											 pathkeys,
+											 required_outer);
+		if (!do_aggregate)
+		{
+			add_path(joinrel, path);
+			success = true;
+		}
+		else
+		{
+			/*
+			 * Try both AGG_HASHED and AGG_SORTED partial aggregation.
+			 *
+			 * AGG_HASHED should not be parameterized because we don't want to
+			 * create the hashtable again for each set of parameters.
+			 */
+			if (required_outer == NULL)
+				success = create_grouped_path(root,
+											  joinrel,
+											  path,
+											  true,
+											  false,
+											  AGG_HASHED,
+											  agg_kind);
+
+			/*
+			 * Don't try AGG_SORTED if create_grouped_path() would reject it
+			 * anyway.
+			 */
+			if (pathkeys != NIL)
+				success = success ||
+					create_grouped_path(root,
+										joinrel,
+										path,
+										true,
+										false,
+										AGG_SORTED,
+										agg_kind);
+		}
 	}
-	else
+
+	if (!success)
 	{
-		/* Waste no memory when we reject a path here */
+		/* Waste no memory when we reject path(s) here */
 		bms_free(required_outer);
 	}
 }
@@ -478,9 +560,28 @@ try_partial_nestloop_path(PlannerInfo *root,
 						  Path *inner_path,
 						  List *pathkeys,
 						  JoinType jointype,
-						  JoinPathExtraData *extra)
+						  JoinPathExtraData *extra,
+						  RelAggKind agg_kind,
+						  bool do_aggregate)
 {
 	JoinCostWorkspace workspace;
+	Path	   *path;
+	PathTarget *target;
+
+	if (agg_kind == REL_AGG_KIND_SIMPLE)
+	{
+		/*
+		 * See create_grouped_path() for explanation why parallel grouping
+		 * paths are not useful w/o final aggregation.
+		 */
+		return;
+	}
+
+	/*
+	 * Fetch the relation to which we'll add the paths.
+	 */
+	if (agg_kind == REL_AGG_KIND_PARTIAL)
+		joinrel = joinrel->grouped->needs_final_agg;
 
 	/*
 	 * If the inner path is parameterized, the parameterization must be fully
@@ -515,7 +616,13 @@ try_partial_nestloop_path(PlannerInfo *root,
 	 */
 	initial_cost_nestloop(root, &workspace, jointype,
 						  outer_path, inner_path, extra);
-	if (!add_partial_path_precheck(joinrel, workspace.total_cost, pathkeys))
+
+	/*
+	 * If the join output should be (partially) aggregated, the precheck
+	 * includes the aggregation and is postponed to create_grouped_path().
+	 */
+	if (!do_aggregate &&
+		!add_partial_path_precheck(joinrel, workspace.total_cost, pathkeys))
 		return;
 
 	/*
@@ -534,18 +641,56 @@ try_partial_nestloop_path(PlannerInfo *root,
 			return;
 	}
 
+	/*
+	 * If the join output is subject to partial aggregation, the path must
+	 * have the appropriate target.
+	 */
+	if (!do_aggregate)
+		target = joinrel->reltarget;
+	else
+	{
+		Assert(joinrel->agg_info != NULL);
+		target = joinrel->agg_info->input;
+	}
+
 	/* Might be good enough to be worth trying, so let's try it. */
-	add_partial_path(joinrel, (Path *)
-					 create_nestloop_path(root,
-										  joinrel,
-										  jointype,
-										  &workspace,
-										  extra,
-										  outer_path,
-										  inner_path,
-										  extra->restrictlist,
-										  pathkeys,
-										  NULL));
+	path = (Path *) create_nestloop_path(root,
+										 joinrel,
+										 target,
+										 jointype,
+										 &workspace,
+										 extra,
+										 outer_path,
+										 inner_path,
+										 extra->restrictlist,
+										 pathkeys,
+										 NULL);
+
+	if (!do_aggregate)
+		add_partial_path(joinrel, path);
+	else
+	{
+		create_grouped_path(root,
+							joinrel,
+							path,
+							true,
+							true,
+							AGG_HASHED,
+							agg_kind);
+
+		/*
+		 * Don't try AGG_SORTED if create_grouped_path() would reject it
+		 * anyway.
+		 */
+		if (pathkeys != NIL)
+			create_grouped_path(root,
+								joinrel,
+								path,
+								true,
+								true,
+								AGG_SORTED,
+								agg_kind);
+	}
 }
 
 /*
@@ -564,15 +709,24 @@ try_mergejoin_path(PlannerInfo *root,
 				   List *innersortkeys,
 				   JoinType jointype,
 				   JoinPathExtraData *extra,
-				   bool is_partial)
+				   bool is_partial,
+				   RelAggKind agg_kind,
+				   bool do_aggregate)
 {
 	Relids		required_outer;
 	JoinCostWorkspace workspace;
+	bool		success = false;
+	RelOptInfo *joinrel_plain = joinrel;
+
+	if (agg_kind == REL_AGG_KIND_PARTIAL)
+		joinrel = joinrel->grouped->needs_final_agg;
+	else if (agg_kind == REL_AGG_KIND_SIMPLE)
+		joinrel = joinrel->grouped->no_final_agg;
 
 	if (is_partial)
 	{
 		try_partial_mergejoin_path(root,
-								   joinrel,
+								   joinrel_plain,
 								   outer_path,
 								   inner_path,
 								   pathkeys,
@@ -580,7 +734,9 @@ try_mergejoin_path(PlannerInfo *root,
 								   outersortkeys,
 								   innersortkeys,
 								   jointype,
-								   extra);
+								   extra,
+								   agg_kind,
+								   do_aggregate);
 		return;
 	}
 
@@ -617,26 +773,70 @@ try_mergejoin_path(PlannerInfo *root,
 						   outersortkeys, innersortkeys,
 						   extra);
 
-	if (add_path_precheck(joinrel,
-						  workspace.startup_cost, workspace.total_cost,
-						  pathkeys, required_outer))
+	if ((!do_aggregate &&
+		 add_path_precheck(joinrel,
+						   workspace.startup_cost, workspace.total_cost,
+						   pathkeys, required_outer)) ||
+		do_aggregate)
 	{
-		add_path(joinrel, (Path *)
-				 create_mergejoin_path(root,
-									   joinrel,
-									   jointype,
-									   &workspace,
-									   extra,
-									   outer_path,
-									   inner_path,
-									   extra->restrictlist,
-									   pathkeys,
-									   required_outer,
-									   mergeclauses,
-									   outersortkeys,
-									   innersortkeys));
+		Path	   *path;
+		PathTarget *target;
+
+		/*
+		 * If the join output is subject to partial aggregation, the path must
+		 * have the appropriate target.
+		 */
+		if (!do_aggregate)
+			target = joinrel->reltarget;
+		else
+		{
+			Assert(joinrel->agg_info != NULL);
+			target = joinrel->agg_info->input;
+		}
+
+		path = (Path *) create_mergejoin_path(root,
+											  joinrel,
+											  target,
+											  jointype,
+											  &workspace,
+											  extra,
+											  outer_path,
+											  inner_path,
+											  extra->restrictlist,
+											  pathkeys,
+											  required_outer,
+											  mergeclauses,
+											  outersortkeys,
+											  innersortkeys);
+		if (!do_aggregate)
+		{
+			add_path(joinrel, path);
+			success = true;
+		}
+		else
+		{
+			if (required_outer == NULL)
+				success = create_grouped_path(root,
+											  joinrel,
+											  path,
+											  true,
+											  false,
+											  AGG_HASHED,
+											  agg_kind);
+
+			if (pathkeys != NIL)
+				success = success ||
+					create_grouped_path(root,
+										joinrel,
+										path,
+										true,
+										false,
+										AGG_SORTED,
+										agg_kind);
+		}
 	}
-	else
+
+	if (!success)
 	{
 		/* Waste no memory when we reject a path here */
 		bms_free(required_outer);
@@ -658,9 +858,28 @@ try_partial_mergejoin_path(PlannerInfo *root,
 						   List *outersortkeys,
 						   List *innersortkeys,
 						   JoinType jointype,
-						   JoinPathExtraData *extra)
+						   JoinPathExtraData *extra,
+						   RelAggKind agg_kind,
+						   bool do_aggregate)
 {
 	JoinCostWorkspace workspace;
+	Path	   *path;
+	PathTarget *target;
+
+	if (agg_kind == REL_AGG_KIND_SIMPLE)
+	{
+		/*
+		 * See create_grouped_path() for explanation why parallel grouping
+		 * paths are not useful w/o final aggregation.
+		 */
+		return;
+	}
+
+	/*
+	 * Fetch the relation to which we'll add the paths.
+	 */
+	if (agg_kind == REL_AGG_KIND_PARTIAL)
+		joinrel = joinrel->grouped->needs_final_agg;
 
 	/*
 	 * See comments in try_partial_hashjoin_path().
@@ -693,24 +912,59 @@ try_partial_mergejoin_path(PlannerInfo *root,
 						   outersortkeys, innersortkeys,
 						   extra);
 
-	if (!add_partial_path_precheck(joinrel, workspace.total_cost, pathkeys))
+	if (!do_aggregate &&
+		!add_partial_path_precheck(joinrel, workspace.total_cost, pathkeys))
 		return;
 
+	/*
+	 * If the join output is subject to partial aggregation, the path must
+	 * have the appropriate target.
+	 */
+	if (!do_aggregate)
+		target = joinrel->reltarget;
+	else
+	{
+		Assert(joinrel->agg_info != NULL);
+		target = joinrel->agg_info->input;
+	}
+
 	/* Might be good enough to be worth trying, so let's try it. */
-	add_partial_path(joinrel, (Path *)
-					 create_mergejoin_path(root,
-										   joinrel,
-										   jointype,
-										   &workspace,
-										   extra,
-										   outer_path,
-										   inner_path,
-										   extra->restrictlist,
-										   pathkeys,
-										   NULL,
-										   mergeclauses,
-										   outersortkeys,
-										   innersortkeys));
+	path = (Path *) create_mergejoin_path(root,
+										  joinrel,
+										  target,
+										  jointype,
+										  &workspace,
+										  extra,
+										  outer_path,
+										  inner_path,
+										  extra->restrictlist,
+										  pathkeys,
+										  NULL,
+										  mergeclauses,
+										  outersortkeys,
+										  innersortkeys);
+
+	if (!do_aggregate)
+		add_partial_path(joinrel, path);
+	else
+	{
+		create_grouped_path(root,
+							joinrel,
+							path,
+							true,
+							true,
+							AGG_HASHED,
+							agg_kind);
+
+		if (pathkeys != NIL)
+			create_grouped_path(root,
+								joinrel,
+								path,
+								true,
+								true,
+								AGG_SORTED,
+								agg_kind);
+	}
 }
 
 /*
@@ -725,10 +979,19 @@ try_hashjoin_path(PlannerInfo *root,
 				  Path *inner_path,
 				  List *hashclauses,
 				  JoinType jointype,
-				  JoinPathExtraData *extra)
+				  JoinPathExtraData *extra,
+				  RelAggKind agg_kind,
+				  bool do_aggregate)
 {
 	Relids		required_outer;
 	JoinCostWorkspace workspace;
+	Path	   *path = NULL;
+	bool		success = false;
+
+	if (agg_kind == REL_AGG_KIND_PARTIAL)
+		joinrel = joinrel->grouped->needs_final_agg;
+	else if (agg_kind == REL_AGG_KIND_SIMPLE)
+		joinrel = joinrel->grouped->no_final_agg;
 
 	/*
 	 * Check to see if proposed path is still parameterized, and reject if the
@@ -745,30 +1008,81 @@ try_hashjoin_path(PlannerInfo *root,
 	}
 
 	/*
+	 * Parameterized execution of grouped path would mean repeated hashing of
+	 * the output of the hashjoin output, so forget about AGG_HASHED if there
+	 * are any parameters. And AGG_SORTED makes no sense because the hash join
+	 * output is not sorted.
+	 */
+	if (required_outer && joinrel->agg_info)
+		return;
+
+	/*
 	 * See comments in try_nestloop_path().  Also note that hashjoin paths
 	 * never have any output pathkeys, per comments in create_hashjoin_path.
 	 */
 	initial_cost_hashjoin(root, &workspace, jointype, hashclauses,
 						  outer_path, inner_path, extra, false);
 
-	if (add_path_precheck(joinrel,
-						  workspace.startup_cost, workspace.total_cost,
-						  NIL, required_outer))
+	/*
+	 * If the join output should be (partially) aggregated, the precheck
+	 * includes the aggregation and is postponed to create_grouped_path().
+	 */
+	if ((!do_aggregate &&
+		 add_path_precheck(joinrel,
+						   workspace.startup_cost, workspace.total_cost,
+						   NIL, required_outer)) ||
+		do_aggregate)
 	{
-		add_path(joinrel, (Path *)
-				 create_hashjoin_path(root,
-									  joinrel,
-									  jointype,
-									  &workspace,
-									  extra,
-									  outer_path,
-									  inner_path,
-									  false,	/* parallel_hash */
-									  extra->restrictlist,
-									  required_outer,
-									  hashclauses));
+		PathTarget *target;
+
+		/*
+		 * If the join output is subject to partial aggregation, the path must
+		 * have the appropriate target.
+		 */
+		if (!do_aggregate)
+			target = joinrel->reltarget;
+		else
+		{
+			Assert(joinrel->agg_info != NULL);
+			target = joinrel->agg_info->input;
+		}
+
+		path = (Path *) create_hashjoin_path(root,
+											 joinrel,
+											 target,
+											 jointype,
+											 &workspace,
+											 extra,
+											 outer_path,
+											 inner_path,
+											 false, /* parallel_hash */
+											 extra->restrictlist,
+											 required_outer,
+											 hashclauses);
+
+		if (!do_aggregate)
+		{
+			add_path(joinrel, path);
+			success = true;
+		}
+		else
+		{
+
+			/*
+			 * As the hashjoin path is not sorted, only try AGG_HASHED.
+			 */
+			if (create_grouped_path(root,
+									joinrel,
+									path,
+									true,
+									false,
+									AGG_HASHED,
+									agg_kind))
+				success = true;
+		}
 	}
-	else
+
+	if (!success)
 	{
 		/* Waste no memory when we reject a path here */
 		bms_free(required_outer);
@@ -792,9 +1106,28 @@ try_partial_hashjoin_path(PlannerInfo *root,
 						  List *hashclauses,
 						  JoinType jointype,
 						  JoinPathExtraData *extra,
-						  bool parallel_hash)
+						  bool parallel_hash,
+						  RelAggKind agg_kind,
+						  bool do_aggregate)
 {
 	JoinCostWorkspace workspace;
+	Path	   *path;
+	PathTarget *target;
+
+	if (agg_kind == REL_AGG_KIND_SIMPLE)
+	{
+		/*
+		 * See create_grouped_path() for explanation why parallel grouping
+		 * paths are not useful w/o final aggregation.
+		 */
+		return;
+	}
+
+	/*
+	 * Fetch the relation to which we'll add the paths.
+	 */
+	if (agg_kind == REL_AGG_KIND_PARTIAL)
+		joinrel = joinrel->grouped->needs_final_agg;
 
 	/*
 	 * If the inner path is parameterized, the parameterization must be fully
@@ -816,23 +1149,55 @@ try_partial_hashjoin_path(PlannerInfo *root,
 	 * cost.  Bail out right away if it looks terrible.
 	 */
 	initial_cost_hashjoin(root, &workspace, jointype, hashclauses,
-						  outer_path, inner_path, extra, parallel_hash);
-	if (!add_partial_path_precheck(joinrel, workspace.total_cost, NIL))
+						  outer_path, inner_path, extra, true);
+
+	/*
+	 * If the join output should be (partially) aggregated, the precheck
+	 * includes the aggregation and is postponed to create_grouped_path().
+	 */
+	if (!do_aggregate &&
+		!add_partial_path_precheck(joinrel, workspace.total_cost, NIL))
 		return;
 
-	/* Might be good enough to be worth trying, so let's try it. */
-	add_partial_path(joinrel, (Path *)
-					 create_hashjoin_path(root,
-										  joinrel,
-										  jointype,
-										  &workspace,
-										  extra,
-										  outer_path,
-										  inner_path,
-										  parallel_hash,
-										  extra->restrictlist,
-										  NULL,
-										  hashclauses));
+	/*
+	 * If the join output is subject to partial aggregation, the path must
+	 * have the appropriate target.
+	 */
+	if (!do_aggregate)
+		target = joinrel->reltarget;
+	else
+	{
+		Assert(joinrel->agg_info != NULL);
+		target = joinrel->agg_info->input;
+	}
+
+	path = (Path *) create_hashjoin_path(root,
+										 joinrel,
+										 target,
+										 jointype,
+										 &workspace,
+										 extra,
+										 outer_path,
+										 inner_path,
+										 parallel_hash,
+										 extra->restrictlist,
+										 NULL,
+										 hashclauses);
+	if (!do_aggregate)
+		add_partial_path(joinrel, path);
+	else
+	{
+		/*
+		 * Only AGG_HASHED is useful, see comments in try_hashjoin_path().
+		 */
+		create_grouped_path(root,
+							joinrel,
+							path,
+							true,
+							true,
+							AGG_HASHED,
+							agg_kind);
+	}
 }
 
 /*
@@ -876,6 +1241,7 @@ clause_sides_match_join(RestrictInfo *rinfo, RelOptInfo *outerrel,
  * 'innerrel' is the inner join relation
  * 'jointype' is the type of join to do
  * 'extra' contains additional input values
+ * 'agg_info' tells if/how to apply partial aggregation to the output.
  */
 static void
 sort_inner_and_outer(PlannerInfo *root,
@@ -883,7 +1249,9 @@ sort_inner_and_outer(PlannerInfo *root,
 					 RelOptInfo *outerrel,
 					 RelOptInfo *innerrel,
 					 JoinType jointype,
-					 JoinPathExtraData *extra)
+					 JoinPathExtraData *extra,
+					 RelAggKind agg_kind,
+					 bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
 	Path	   *outer_path;
@@ -1045,7 +1413,9 @@ sort_inner_and_outer(PlannerInfo *root,
 						   innerkeys,
 						   jointype,
 						   extra,
-						   false);
+						   false,
+						   agg_kind,
+						   do_aggregate);
 
 		/*
 		 * If we have partial outer and parallel safe inner path then try
@@ -1061,7 +1431,9 @@ sort_inner_and_outer(PlannerInfo *root,
 									   outerkeys,
 									   innerkeys,
 									   jointype,
-									   extra);
+									   extra,
+									   agg_kind,
+									   do_aggregate);
 	}
 }
 
@@ -1089,7 +1461,9 @@ generate_mergejoin_paths(PlannerInfo *root,
 						 bool useallclauses,
 						 Path *inner_cheapest_total,
 						 List *merge_pathkeys,
-						 bool is_partial)
+						 bool is_partial,
+						 RelAggKind agg_kind,
+						 bool do_aggregate)
 {
 	List	   *mergeclauses;
 	List	   *innersortkeys;
@@ -1150,7 +1524,9 @@ generate_mergejoin_paths(PlannerInfo *root,
 					   innersortkeys,
 					   jointype,
 					   extra,
-					   is_partial);
+					   is_partial,
+					   agg_kind,
+					   do_aggregate);
 
 	/* Can't do anything else if inner path needs to be unique'd */
 	if (save_jointype == JOIN_UNIQUE_INNER)
@@ -1247,7 +1623,9 @@ generate_mergejoin_paths(PlannerInfo *root,
 							   NIL,
 							   jointype,
 							   extra,
-							   is_partial);
+							   is_partial,
+							   agg_kind,
+							   do_aggregate);
 			cheapest_total_inner = innerpath;
 		}
 		/* Same on the basis of cheapest startup cost ... */
@@ -1291,7 +1669,9 @@ generate_mergejoin_paths(PlannerInfo *root,
 								   NIL,
 								   jointype,
 								   extra,
-								   is_partial);
+								   is_partial,
+								   agg_kind,
+								   do_aggregate);
 			}
 			cheapest_startup_inner = innerpath;
 		}
@@ -1333,7 +1713,9 @@ match_unsorted_outer(PlannerInfo *root,
 					 RelOptInfo *outerrel,
 					 RelOptInfo *innerrel,
 					 JoinType jointype,
-					 JoinPathExtraData *extra)
+					 JoinPathExtraData *extra,
+					 RelAggKind agg_kind,
+					 bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
 	bool		nestjoinOK;
@@ -1456,7 +1838,9 @@ match_unsorted_outer(PlannerInfo *root,
 							  inner_cheapest_total,
 							  merge_pathkeys,
 							  jointype,
-							  extra);
+							  extra,
+							  agg_kind,
+							  do_aggregate);
 		}
 		else if (nestjoinOK)
 		{
@@ -1478,7 +1862,9 @@ match_unsorted_outer(PlannerInfo *root,
 								  innerpath,
 								  merge_pathkeys,
 								  jointype,
-								  extra);
+								  extra,
+								  agg_kind,
+								  do_aggregate);
 			}
 
 			/* Also consider materialized form of the cheapest inner path */
@@ -1489,7 +1875,9 @@ match_unsorted_outer(PlannerInfo *root,
 								  matpath,
 								  merge_pathkeys,
 								  jointype,
-								  extra);
+								  extra,
+								  agg_kind,
+								  do_aggregate);
 		}
 
 		/* Can't do anything else if outer path needs to be unique'd */
@@ -1504,7 +1892,7 @@ match_unsorted_outer(PlannerInfo *root,
 		generate_mergejoin_paths(root, joinrel, innerrel, outerpath,
 								 save_jointype, extra, useallclauses,
 								 inner_cheapest_total, merge_pathkeys,
-								 false);
+								 false, agg_kind, do_aggregate);
 	}
 
 	/*
@@ -1525,7 +1913,8 @@ match_unsorted_outer(PlannerInfo *root,
 	{
 		if (nestjoinOK)
 			consider_parallel_nestloop(root, joinrel, outerrel, innerrel,
-									   save_jointype, extra);
+									   save_jointype, extra, agg_kind,
+									   do_aggregate);
 
 		/*
 		 * If inner_cheapest_total is NULL or non parallel-safe then find the
@@ -1545,7 +1934,9 @@ match_unsorted_outer(PlannerInfo *root,
 		if (inner_cheapest_total)
 			consider_parallel_mergejoin(root, joinrel, outerrel, innerrel,
 										save_jointype, extra,
-										inner_cheapest_total);
+										inner_cheapest_total,
+										agg_kind,
+										do_aggregate);
 	}
 }
 
@@ -1568,7 +1959,9 @@ consider_parallel_mergejoin(PlannerInfo *root,
 							RelOptInfo *innerrel,
 							JoinType jointype,
 							JoinPathExtraData *extra,
-							Path *inner_cheapest_total)
+							Path *inner_cheapest_total,
+							RelAggKind agg_kind,
+							bool do_aggregate)
 {
 	ListCell   *lc1;
 
@@ -1586,7 +1979,8 @@ consider_parallel_mergejoin(PlannerInfo *root,
 
 		generate_mergejoin_paths(root, joinrel, innerrel, outerpath, jointype,
 								 extra, false, inner_cheapest_total,
-								 merge_pathkeys, true);
+								 merge_pathkeys, true, agg_kind,
+								 do_aggregate);
 	}
 }
 
@@ -1607,7 +2001,9 @@ consider_parallel_nestloop(PlannerInfo *root,
 						   RelOptInfo *outerrel,
 						   RelOptInfo *innerrel,
 						   JoinType jointype,
-						   JoinPathExtraData *extra)
+						   JoinPathExtraData *extra,
+						   RelAggKind agg_kind,
+						   bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
 	ListCell   *lc1;
@@ -1657,7 +2053,8 @@ consider_parallel_nestloop(PlannerInfo *root,
 			}
 
 			try_partial_nestloop_path(root, joinrel, outerpath, innerpath,
-									  pathkeys, jointype, extra);
+									  pathkeys, jointype, extra, agg_kind,
+									  do_aggregate);
 		}
 	}
 }
@@ -1672,6 +2069,7 @@ consider_parallel_nestloop(PlannerInfo *root,
  * 'innerrel' is the inner join relation
  * 'jointype' is the type of join to do
  * 'extra' contains additional input values
+ * 'agg_info' tells if/how to apply partial aggregation to the output.
  */
 static void
 hash_inner_and_outer(PlannerInfo *root,
@@ -1679,7 +2077,9 @@ hash_inner_and_outer(PlannerInfo *root,
 					 RelOptInfo *outerrel,
 					 RelOptInfo *innerrel,
 					 JoinType jointype,
-					 JoinPathExtraData *extra)
+					 JoinPathExtraData *extra,
+					 RelAggKind agg_kind,
+					 bool do_aggregate)
 {
 	JoinType	save_jointype = jointype;
 	bool		isouterjoin = IS_OUTER_JOIN(jointype);
@@ -1754,7 +2154,9 @@ hash_inner_and_outer(PlannerInfo *root,
 							  cheapest_total_inner,
 							  hashclauses,
 							  jointype,
-							  extra);
+							  extra,
+							  agg_kind,
+							  do_aggregate);
 			/* no possibility of cheap startup here */
 		}
 		else if (jointype == JOIN_UNIQUE_INNER)
@@ -1770,7 +2172,9 @@ hash_inner_and_outer(PlannerInfo *root,
 							  cheapest_total_inner,
 							  hashclauses,
 							  jointype,
-							  extra);
+							  extra,
+							  agg_kind,
+							  do_aggregate);
 			if (cheapest_startup_outer != NULL &&
 				cheapest_startup_outer != cheapest_total_outer)
 				try_hashjoin_path(root,
@@ -1779,7 +2183,9 @@ hash_inner_and_outer(PlannerInfo *root,
 								  cheapest_total_inner,
 								  hashclauses,
 								  jointype,
-								  extra);
+								  extra,
+								  agg_kind,
+								  do_aggregate);
 		}
 		else
 		{
@@ -1800,7 +2206,9 @@ hash_inner_and_outer(PlannerInfo *root,
 								  cheapest_total_inner,
 								  hashclauses,
 								  jointype,
-								  extra);
+								  extra,
+								  agg_kind,
+								  do_aggregate);
 
 			foreach(lc1, outerrel->cheapest_parameterized_paths)
 			{
@@ -1834,7 +2242,9 @@ hash_inner_and_outer(PlannerInfo *root,
 									  innerpath,
 									  hashclauses,
 									  jointype,
-									  extra);
+									  extra,
+									  agg_kind,
+									  do_aggregate);
 				}
 			}
 		}
@@ -1877,7 +2287,9 @@ hash_inner_and_outer(PlannerInfo *root,
 										  cheapest_partial_outer,
 										  cheapest_partial_inner,
 										  hashclauses, jointype, extra,
-										  true /* parallel_hash */ );
+										  true /* parallel_hash */ ,
+										  agg_kind,
+										  do_aggregate);
 			}
 
 			/*
@@ -1898,7 +2310,9 @@ hash_inner_and_outer(PlannerInfo *root,
 										  cheapest_partial_outer,
 										  cheapest_safe_inner,
 										  hashclauses, jointype, extra,
-										  false /* parallel_hash */ );
+										  false /* parallel_hash */ ,
+										  agg_kind,
+										  do_aggregate);
 		}
 	}
 }
